// Billboards.h: interface for the CBillboards class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BILLBOARDS_H
#define AFX_BILLBOARDS_H

#include <d3d8.h>
#include <d3dx8.h>

#include <vector>
#include "Logging.h"
#include "defines.h"
#include "MatrixCalls.h"
#include "Structs.h"
#include "Camera.h"



class CBillboards  
{

struct LitVertex
{
	float x,y,z;
	DWORD color;
	float u,v;
};

public:
	CBillboards();
	virtual ~CBillboards();

	bool InitializeBillboard(LPDIRECT3DDEVICE8 device, std::vector<char*> textureFileNames);

	bool DrawBillboard(LPDIRECT3DDEVICE8 device, D3DXMATRIX ViewMatrix, D3DXVECTOR3 Rotation, Billboard *billboard);


private:

	std::vector<LPDIRECT3DTEXTURE8> Textures;

	D3DXMATRIX billboardMatrix;

	int i;

	long		time_last;

};

#endif 
