// D3DInitialize.h: interface for the CD3DInitialize class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_D3DINITIALIZE_H)
#define AFX_D3DINITIALIZE_H

#include <d3d8.h>
#include <d3dx8.h>
#include <vector>

#include "Logging.h"
#include "defines.h"


using namespace std;

class CD3DInitialize  
{
public:
	CD3DInitialize();
	virtual ~CD3DInitialize();

	bool	InitializeD3D(HWND hwnd, int width, int height, bool fullscreen, 
							LPDIRECT3DDEVICE8 &dev, LPDIRECT3D8 &d3d);

protected:
	/////////////////////////////////////////////
	//functions

	bool	    GetBackBufferFormat(int bit_depth, int alpha_bits, D3DFORMAT display_format,
									D3DFORMAT *bb_format);

	D3DFORMAT   GetDepthBufferFormat(LPDIRECT3D8 d3d, D3DFORMAT DisplayFormat, 
									bool use_stencil, int bpp);

	int			BuildDisplayModeList(LPDIRECT3D8 d3d);


	bool        EvaluateDeviceCapabilities(const LPDIRECT3DDEVICE8 device);

private:

	////////////////////////////////////////////
	//hardware capabilities
	int   max_texture_stages;
	int   max_texture_width;
	int   max_texture_height;
	int   max_active_lights;
	int   max_streams;
	float max_point_size;

	bool windowed_acceleration;
	bool pure_device;
	bool hardware_TNL;
	bool hardware_rasterization;
	bool does_texgen;
	bool does_zbias;
	bool stencil_support;

	int num_modes;
	int num_formats;

	std::vector <D3DDISPLAYMODE> DisplayModes;

	D3DFORMAT Formats[20];
	
	bool Cursor;

};

#endif