// Game.h: interface for the CGame class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_GAME_H)
#define AFX_GAME_H

#include <vector>

#include <dinput.h>
#include <d3d8.h>
#include <d3dx8.h>

#include "XFile.h"
#include "D3DInitialize.h"
#include "RenderStates.h"
#include "Camera.h"
#include "defines.h"
#include "structs.h"
#include "MatrixCalls.h"
#include "SkyBox.h"
#include "Billboards.h"
#include "ParticleSystem.h"



class CGame  
{

public:
	CGame();
	virtual ~CGame();

	bool InitializeGame(HINSTANCE hInstance, HWND hwnd, int screen_width, int screen_height, bool fullscreen);
	
	bool Process();

	bool InitializeInput(HINSTANCE hInstance, HWND hwnd);

	void CheckKeyboardInput(long elapsed_ms);
	
	void CheckMouseInput();


private:


	LPDIRECT3D8			d3d;
	LPDIRECT3DDEVICE8	device;

	CRenderStates		myRenderStates;
	CCamera				myCamera;
	LPDIRECT3DTEXTURE8	detailmap;

	LPDIRECTINPUT8			dInput;
	LPDIRECTINPUTDEVICE8	keyboard;
	LPDIRECTINPUTDEVICE8	mouse;

	int sensitivity;  //lower number = more sensitivity
	int keyboardspeed;


	//////////////////////////////////////////////////////////////////
	//place variables here
	
	int					LightningTime;
	bool				playing;
	bool				loopagain;
	int					RainMore;
	float				WindSpeed;
	int					RainDelay;
	bool				FireVisible;

	CSkyBox				mySkyBox;

	LightObject			pointLight;
	LightObject			ambientLight;
	
	CXFile				myXFile;
	XObject				tiger;

	CXFile				myXFile2;
	XObject				tiger2;

	CBillboards			myBillboards;
	Billboard			Fire;

	CBillboards			myBillboards2;
	Billboard			Log;

	CBillboards			myBillboards3;
	Billboard			Lightning;

	CBillboards			myBillboards4;
	Billboard			Cloud;

	CBillboards			myBillboards5;
	Billboard			Cloud1;

	CBillboards			myBillboards6;
	Billboard			Cloud2;

	CBillboards			myBillboards7;
	Billboard			Cloud3;


	CParticleSystem		myParticleSystem;
	ParticleEmitter		Smoke;

	CParticleSystem		myParticleSystem2;
	ParticleEmitter		Rain;

	CParticleSystem		myParticleSystem3;
	ParticleEmitter		Explotion;



};

#endif