// MatrixCalls.cpp: implementation of the CMatrixCalls class.
//
//////////////////////////////////////////////////////////////////////
#pragma warning( disable : 4244 )

#include "MatrixCalls.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


D3DXMATRIX GetIdentityMatrix()
{
	{
		D3DXMATRIX	M;
		
		ZeroMemory( &M, sizeof(M) );
		M._11 = 1;
		M._22 = 1;
		M._33 = 1;
		M._44 = 1;
		return M;
	}
}

D3DXMATRIX RotateYawPitchRoll(D3DXMATRIX m, float x, float y, float z)
{
	D3DXMATRIX temp;

	x = EIMATH_DEGTORAD(x);
	y = EIMATH_DEGTORAD(y);
	z = EIMATH_DEGTORAD(z);

	D3DXMatrixRotationYawPitchRoll(&temp, x, y, z);
	
	D3DXMatrixMultiply(&temp, &temp, &m);

	return temp;
}

D3DXMATRIX Scale(D3DXMATRIX m, float x, float y, float z)
{

	m._11 = x;
	m._13 = y;
	m._31 = z;

	return m;
}