// RenderStates.h: interface for the CRenderStates class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_RENDERSTATES_H)
#define AFX_RENDERSTATES_H

#include <d3d8.h>
#include <d3dx8.h>

#include "Logging.h"
#include "defines.h"
#include "MatrixCalls.h"
#include "Structs.h"


class CRenderStates  
{
public:
	CRenderStates();
	virtual ~CRenderStates();
	
	bool InitializeRenderStates(LPDIRECT3DDEVICE8 device);

	void CreateLight(LightObject *myLight, LPDIRECT3DDEVICE8 device);

	void LightOn(int LightNumber, LPDIRECT3DDEVICE8 device);

	void LightOff(int LightNumber, LPDIRECT3DDEVICE8 device);

private:

	int LightNumber;

	D3DXMATRIX ScalingMatrix; // for scaling detail map

};

#endif