// SkyBox.h: interface for the CSkyBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SKYBOX_H
#define AFX_SKYBOX_H

#include <d3d8.h>
#include <d3dx8.h>

#include <vector>
#include "Logging.h"
#include "defines.h"
#include "MatrixCalls.h"
#include "Structs.h"
#include "Camera.h"


class CSkyBox 
{

struct LitVertex
{
	float x,y,z;
	DWORD color;
	float u,v;
};

public:
	CSkyBox();
	virtual ~CSkyBox();

	bool DrawSkybox(LPDIRECT3DDEVICE8 device,float Size, DWORD Color);

	bool InitializeSkybox(LPDIRECT3DDEVICE8 device,char* filenameFront,char* filenameBack,
						char* filenameLeft,char* filenameRight,char* filenameUp,char* Down);

private:

	std::vector<LPDIRECT3DTEXTURE8> Textures;

	D3DXMATRIX identity;

};

#endif
