#ifndef _STRUCTSDEFINED
#define _STRUCTSDEFINED

#include <d3d8.h>
#include <d3dx8.h>
#include <vector>

struct LightObject
{
	D3DLIGHT8		Light; // zero memory just to make sure
	D3DLIGHTTYPE    Type;  // D3DLIGHT_DIRECTIONAL || D3DLIGHT_POINT || D3DLIGHT_SPOT
    D3DCOLORVALUE   Diffuse;
    D3DCOLORVALUE   Specular;
    D3DCOLORVALUE   Ambient;
    D3DXVECTOR3     Position;
    D3DXVECTOR3     Direction; //0,-1,0 for straight down
    float           Range;
    float           Falloff;  // should be 1 for most use
    float           Attenuation0; // should be 0 for most use
    float           Attenuation1; // should be 1 for most use
    float           Attenuation2; // should be 0 for most use
    float           Theta;   //rad inner cone
    float           Phi;     //rad outer cone

	int				LightNumber;

};

struct XObject // Create a new CXFile Class for each X file
{
	char*				filename;

	char				filenameLoc[500];

	D3DXMATRIX			WorldMatrix;
};


struct ParticleEmitter // Create a new CParticleSystem Class for each billboard
{
	D3DXVECTOR3		Position;
	D3DXVECTOR3		Radius;
	float			ParticleSize;
	float			ScaleX;
	float			ScaleY;
	float			ScaleZ;
	float			Delay;
	int				MaxParticles;				
	int				NumParticlesToEmit;
	int				MaxRandVelocity;
	int				MinRandVelocity;
	D3DXVECTOR3		MaxRandParticleDirection;  //rad degree between 1 and -1
	D3DXVECTOR3		MinRandParticleDirection;
	D3DXCOLOR		StartColor; 
	D3DXCOLOR		EndColor;  
	D3DXCOLOR		ColorFade;	//(1,1,1,1) would be a slow fade for all colors;
	float			MaxLifeTime;  
	float			Gravity;	  
	float			AirResitance;	  
	bool			Active;

	char *			TextureFilename;
};

struct Billboard  // Create a new CBillboards Class for each billboard
{

	std::vector<char*> texturenames;
	D3DXVECTOR3		Location;
	D3DXVECTOR3		Size;
	float			AnimationDelay;
	int				Delay;
	DWORD			Color;
	bool			RotateY;

};


#endif