// XFile.h: interface for the CXFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XFILE_H)
#define AFX_XFILE_H

#include "structs.h"
#include <vector>
#include <d3d8.h>
#include <d3dx8.h>
#include "logging.h"
#include "defines.h"

class CXFile  
{
public:
	CXFile();
	virtual ~CXFile();

	bool LoadXFile(XObject *object, LPDIRECT3DDEVICE8 device);

	bool Render(XObject *object, LPDIRECT3DDEVICE8 device);

private:

	std::vector<D3DMATERIAL8>		materials;

	std::vector<LPDIRECT3DTEXTURE8> textures; 

	DWORD							m_numMaterials;

	LPD3DXMESH			mesh; 
		
};

#endif
